.org 0x0000						jmp			RESET
;############################################################################################################################################
.org CRCSCAN_NMI_vect			reti;rjmp		CRCSCAN_NMI_INT
.org BOD_VLM_vect				reti;rjmp		BOD_VLM_INT
#if	defined	EXT_RESET && RST_PORT == PORTA_base
.org PORTA_PORT_vect			rjmp		PORTA_PORT_INT
#else
.org PORTA_PORT_vect			reti;rjmp		PORTA_PORT_INT
#endif
#if	defined	EXT_RESET && RST_PORT == PORTB_base
.org PORTB_PORT_vect			rjmp		PORTB_PORT_INT
#else
.org PORTB_PORT_vect			reti;rjmp		PORTB_PORT_INT
#endif
.org RTC_CNT_vect				reti;rjmp		RTC_CNT_INT
.org RTC_PIT_vect				reti;rjmp		RTC_PIT_INT
;.org TCA0_LUNF_vect			reti;rjmp		TCA0_LUNF_INT
.org TCA0_OVF_vect				reti;rjmp		TCA0_OVF_INT
;.org TCA0_HUNF_vect			reti;rjmp		TCA0_HUNF_INT
;.org TCA0_LCMP0_vect			reti;rjmp		TCA0_LCMP0_INT
.org TCA0_CMP0_vect				reti;rjmp		TCA0_CMP0_INT
.org TCA0_CMP1_vect				reti;rjmp		TCA0_CMP1_INT
;.org TCA0_LCMP1_vect			reti;rjmp		TCA0_LCMP1_INT
.org TCA0_CMP2_vect				reti;rjmp		TCA0_CMP2_INT
;.org TCA0_LCMP2_vect			reti;rjmp		TCA0_LCMP2_INT
.org TCB0_INT_vect				reti;rjmp		TCB0_INT_INT
.org TCB1_INT_vect				reti;rjmp		TCB1_INT_INT
.org TCD0_OVF_vect				reti;rjmp		TCD0_OVF_INT
.org TCD0_TRIG_vect				reti;rjmp		TCD0_TRIG_INT
.org AC0_AC_vect				reti;rjmp		AC0_AC_INT
.org AC1_AC_vect				reti;rjmp		AC1_AC_INT
.org AC2_AC_vect				reti;rjmp		AC2_AC_INT
.org ADC0_RESRDY_vect 			reti;rjmp		ADC0_RESRDY_INT
.org ADC0_WCOMP_vect			reti;rjmp		ADC0_WCOMP_INT
.org ADC1_RESRDY_vect 			reti;rjmp		ADC1_RESRDY_INT
.org ADC1_WCOMP_vect			reti;rjmp		ADC1_WCOMP_INT
.org TWI0_TWIS_vect				reti;rjmp		TWI0_TWIS_INT
.org TWI0_TWIM_vect				reti;rjmp		TWI0_TWIM_INT
.org SPI0_INT_vect				reti;rjmp		SPI0_INT_INT
.org USART0_RXC_vect			reti;rjmp		USART0_RXC_INT
.org USART0_DRE_vect			reti;rjmp		USART0_DRE_INT
.org USART0_TXC_vect			reti;rjmp		USART0_TXC_INT
.org NVMCTRL_EE_vect 			reti;rjmp		NVMCTRL_EE_INT
;############################################################################################################################################
.org INT_VECTORS_SIZE

#if	defined	EXT_RESET && RST_PORT == PORTA_base
PORTA_PORT_INT:			// ext.RESET	PORT_INT7_bp
		lds		iSREG,(CPU_SREG)
		lds		iTEMPA,((RST_PORT)+(PORT_INTFLAGS_offset))		; PORTB_INTFLAGS
		sbrc	iTEMPA,(RST_PIN)								; PORT_INT1_bp
		rcall	EXT_RESETA_DETECT
		
PORTA_PORT_INT_END:
		ser		iTEMPA
		sts		((RST_PORT)+(PORT_INTFLAGS_offset)),iTEMPA		; PORTB_INTFLAGS
		sts		CPU_SREG,iSREG	
		reti

EXT_RESETA_DETECT:
		ldi		iTEMPA,(1<<RSTCTRL_SWRE_bp)
		ldi		r16,(CPU_CCP_IOREG_gc)
		out		(CPU_CCP),r16
		sts		(RSTCTRL_SWRR),iTEMPA
		ret
#endif


#if	defined	EXT_RESET && RST_PORT == PORTB_base
PORTB_PORT_INT:			// ext.RESET	PORT_INT7_bp
		lds		iSREG,(CPU_SREG)
		lds		iTEMPA,((RST_PORT)+(PORT_INTFLAGS_offset))		; PORTB_INTFLAGS
		sbrc	iTEMPA,(RST_PIN)								; PORT_INT1_bp
		rcall	EXT_RESETB_DETECT
		
PORTB_PORT_INT_END:
		ser		iTEMPA
		sts		((RST_PORT)+(PORT_INTFLAGS_offset)),iTEMPA		; PORTB_INTFLAGS
		sts		CPU_SREG,iSREG	
		reti

EXT_RESETB_DETECT:
		ldi		iTEMPA,(1<<RSTCTRL_SWRE_bp)
		ldi		r16,(CPU_CCP_IOREG_gc)
		out		(CPU_CCP),r16
		sts		(RSTCTRL_SWRR),iTEMPA
		ret
#endif
